# bbRepMask.sql was originally generated by the autoSql program, which also 
# generated bbRepMask.c and bbRepMask.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#BB Repeat Masker Representation
CREATE TABLE bbRepMask (
    seqId tinyint unsigned not null,	# Id of chromosome
    seqStart int unsigned not null,	# Start in sequence
    seqEnd int unsigned not null,	# End in sequence
    bin smallint unsigned not null,	# Which bin it's in.
    name varchar(255) not null,	# Name of repeat
    score int unsigned not null,	# Smith-Waterman score.
    strand char(1) not null,	# Query strand (+ or C)
    repFamily varchar(255) not null,	# Repeat name
    repStart int not null,	# Start position in repeat.
    repEnd int not null,	# End position in repeat.
    repLeft int not null,	# Bases left in repeat.
    milliDiv int unsigned not null,	# Base mismatches in parts per thousand
    milliDel int unsigned not null,	# Bases deleted in parts per thousand
    milliIns int unsigned not null,	# Bases inserted in parts per thousand
              #Indices
    INDEX(bin),
    UNIQUE(seqStart),
    UNIQUE(seqEnd)
);
