/* minGeneInfo.c was originally generated by the autoSql program, which also 
 * generated minGeneInfo.h and minGeneInfo.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "minGeneInfo.h"

static char const rcsid[] = "$Id: minGeneInfo.c,v 1.1 2003/06/30 21:49:52 aamp Exp $";

void minGeneInfoStaticLoad(char **row, struct minGeneInfo *ret)
/* Load a row from minGeneInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->name = row[0];
ret->product = row[1];
ret->note = row[2];
}

struct minGeneInfo *minGeneInfoLoad(char **row)
/* Load a minGeneInfo from row fetched with select * from minGeneInfo
 * from database.  Dispose of this with minGeneInfoFree(). */
{
struct minGeneInfo *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->product = cloneString(row[1]);
ret->note = cloneString(row[2]);
return ret;
}

struct minGeneInfo *minGeneInfoLoadAll(char *fileName) 
/* Load all minGeneInfo from a whitespace-separated file.
 * Dispose of this with minGeneInfoFreeList(). */
{
struct minGeneInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileRow(lf, row))
    {
    el = minGeneInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct minGeneInfo *minGeneInfoLoadAllByChar(char *fileName, char chopper) 
/* Load all minGeneInfo from a chopper separated file.
 * Dispose of this with minGeneInfoFreeList(). */
{
struct minGeneInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = minGeneInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct minGeneInfo *minGeneInfoLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all minGeneInfo from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with minGeneInfoFreeList(). */
{
struct minGeneInfo *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = minGeneInfoLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void minGeneInfoSaveToDb(struct sqlConnection *conn, struct minGeneInfo *el, char *tableName, int updateSize)
/* Save minGeneInfo as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use minGeneInfoSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s','%s','%s')", 
	tableName,  el->name,  el->product,  el->note);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void minGeneInfoSaveToDbEscaped(struct sqlConnection *conn, struct minGeneInfo *el, char *tableName, int updateSize)
/* Save minGeneInfo as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than minGeneInfoSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *name, *product, *note;
name = sqlEscapeString(el->name);
product = sqlEscapeString(el->product);
note = sqlEscapeString(el->note);

dyStringPrintf(update, "insert into %s values ( '%s','%s','%s')", 
	tableName,  name,  product,  note);
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&name);
freez(&product);
freez(&note);
}

struct minGeneInfo *minGeneInfoCommaIn(char **pS, struct minGeneInfo *ret)
/* Create a minGeneInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new minGeneInfo */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->product = sqlStringComma(&s);
ret->note = sqlStringComma(&s);
*pS = s;
return ret;
}

void minGeneInfoFree(struct minGeneInfo **pEl)
/* Free a single dynamically allocated minGeneInfo such as created
 * with minGeneInfoLoad(). */
{
struct minGeneInfo *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->product);
freeMem(el->note);
freez(pEl);
}

void minGeneInfoFreeList(struct minGeneInfo **pList)
/* Free a list of dynamically allocated minGeneInfo's */
{
struct minGeneInfo *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    minGeneInfoFree(&el);
    }
*pList = NULL;
}

void minGeneInfoOutput(struct minGeneInfo *el, FILE *f, char sep, char lastSep) 
/* Print out minGeneInfo.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->product);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->note);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

