# pseudoGeneLink.sql was originally generated by the autoSql program, which also 
# generated pseudoGeneLink.c and pseudoGeneLink.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#links a gene/pseudogene prediction to an ortholog or paralog.
CREATE TABLE pseudoGeneLink (
    name varchar(255) not null,	# Name of pseudogene
    score int unsigned not null,	# score of pseudogene with gene
    assembly varchar(255) not null,	# assembly for gene
    geneTable varchar(255) not null,	# mysql table of gene
    gene varchar(255) not null,	# Name of gene
    chrom varchar(255) not null,	# Chromosome name
    gStart int unsigned not null,	# gene alignment start position
    gEnd int unsigned not null,	# gene alignment end position
    score2 int unsigned not null,	# intron score of pseudogene with gap
    score3 int unsigned not null,	# intron score of pseudogene
    chainId int unsigned not null,	# chain id of gene/pseudogene alignment
    strand varchar(255) not null,	# strand of gene
    polyA int unsigned not null,	# length of polyA
    polyAstart int unsigned not null,	# start f polyA
    pchrom varchar(255) not null,	# Chromosome name for pseudogene
    pStart int unsigned not null,	# pseudogene alignment start position
    pEnd int unsigned not null,	# pseudogene alignment end position
    pStrand varchar(255) not null,	# strand of pseudoegene
              #Indices
    PRIMARY KEY(name,pchrom(5),pStart)
);
